<?php
function uc_acar_admin_conf_frm($frm, &$sta){
	$cfg = uc_acar_cfg();
	
	
	$frm['saf'] = array(
		
		'#type' => 'checkbox',
		'#title' => 'Безопасный режим.',
		'#default_value' => $cfg['saf'],
		'#description' => ''
	);
  
  
	$frm['atr'] = array(
		'#type' => 'checkbox',
		'#title' => 'Подключать информацию о атрибутах.',
		'#default_value' => $cfg['atr'],		
		'#description' => ''
	);
	$frm['sku'] = array(
		'#type' => 'checkbox',
		'#title' => 'Подключать информацию о SKU.',
		'#default_value' => $cfg['sku'],		
		'#description' => ''
	);
	$frm['sto'] = array(
		'#type' => 'checkbox',
		'#title' => 'Подключать информацию о складе.',
		'#default_value' => $cfg['sto'],		
		'#description' => ''
	);
	$frm['tpl_pan'] = array(
		'#type' => 'textfield',
		'#title' => 'Шаблон формы корзины отображаемой на странице корзины.',
		'#default_value' => $cfg['tpl_pan'],
	);
	$frm['tpl_blo'] = array(
		'#type' => 'textfield',
		'#title' => 'Шаблон формы корзины отображаемой в блоке.',
		'#default_value' => $cfg['tpl_blo'],
	);
	$frm['img'] = array(
		'#type' => 'textfield',
		'#title' => 'Стиль изображения картинки продукта.',
		'#default_value' => $cfg['img'],
	);
	
	$frm['qty_sto'] = array(
		'#type' => 'checkbox',
		'#title' => 'Ограничивать максимальное количество товара, запасом товара на складе.',
		'#default_value' => $cfg['qty_sto'],
		'#description' =>
'Эта опция не позволит добавить в корзину количество товара, больше чем есть на складе. Даже если товар был помещен в корзину до того как произошло списание, при следующим посещении корзины количество товара будет соответствующим образом урезано.<br/>
Для правильной работы данной опции необходимо что бы была активирована опция "Подключения информации о складе", а так же, если различные комбиации атрибутов имеют разные SKU, опция "Подключения информации о SKU".'
	);
	
	$frm[] = array(
		'#type' => 'submit',
		'#value' => 'Save'
	);
	return $frm;
}
function uc_acar_admin_conf_frm_submit($frm, &$sta){
	$cfg = uc_acar_cfg();
	$cfg['saf'] = $sta['values']['saf'];
	
	$cfg['atr'] = $sta['values']['atr'];
	$cfg['sku'] = $sta['values']['sku'];
	$cfg['sto'] = $sta['values']['sto'];
	$cfg['tpl_pan'] = $sta['values']['tpl_pan'];
	$cfg['tpl_blo'] = $sta['values']['tpl_blo'];
	$cfg['img'] = $sta['values']['img'];
	$cfg['qty_sto'] = $sta['values']['qty_sto'];
	uc_acar_cfg($cfg);	
}
function uc_acar_admin_mass_frm($frm, &$sta){


	$q = db_select('field_config', 't');
	$q->innerJoin('field_config_instance', 'i', 'i.field_name = t.field_name');
	$fie = $q->condition('t.type', 'uc_acar')
		->fields('i', array('field_name', 'bundle'))
		->execute()
		->fetchAll();
	
	$fie_sel = array();
	foreach($fie as $f){
		$fie_sel[$f->bundle.'.'.$f->field_name] = '['.$f->bundle.'] '.$f->field_name;
	}
	
	$frm[] = array(
		'#markup' =>
'<div class="form-item">
<div class="description">Массовое изменение шаблона всех нод для указанного поля.</div>
</div>'
	);
	$frm['fie'] = array(
		'#type' => 'select',
		'#title' => 'Поле',
		'#options' => $fie_sel,
	);	
	$frm['vie'] = array(
		'#type' => 'select',
		'#title' => 'Form',
		'#options' => array(
			uc_acar::VIE_PRO => 'Product',
			uc_acar::VIE_CAR => 'Cart'
		),
	);
	$frm['tpl'] = array(
		'#type' => 'textfield',
		'#title' => 'Template',
	);

	$upd_atr = array();
	if(empty($fie_sel)) $upd_atr['disabled'] = 'disabled';
	$frm['upd'] = array(
		'#type' => 'submit',
		'#value' => 'Обновить',
		'#attributes' => $upd_atr,
	);

	return $frm;

}
function uc_acar_admin_mass_frm_submit($frm, &$sta){

	if($sta['values']['op'] == $sta['values']['upd']){
	
		ignore_user_abort(true);
		set_time_limit(0);
	
		$fie = explode('.', $sta['values']['fie']);
	
		
		if(empty($sta['values']['tpl'])){
						db_delete('field_data_'.$fie[1])
				->condition('entity_type', 'node')
				->condition('bundle', $fie[0])
				->execute();
			db_delete('field_revision_'.$fie[1])
				->condition('entity_type', 'node')
				->condition('bundle', $fie[0])
				->execute();			
			
		}else{
						
			$nid = db_select('node', 't')->condition('t.type', $fie[0])->fields('t', array('nid'))->execute()->fetchCol();

			
			
			foreach($nid as $n){
			
						
				$ava = db_select('field_data_'.$fie[1], 't')->condition('t.entity_id', $n)->countQuery()->execute()->fetchField();
				
				if(!$ava){
					
					db_insert('field_data_'.$fie[1])
						->fields(array(
							'entity_type' => 'node',
							'bundle' => $fie[0],
							'deleted' => 0,
							'entity_id' => $n,
							'revision_id' => null,
							'language' => 'und',
							'delta' => 0,
							$fie[1].'_dat' => serialize(array(
								'vie' => (int)$sta['values']['vie'],
								'tpl' => $sta['values']['tpl'],
							)),
						))
						->execute();
					
				}else{

					db_update('field_data_'.$fie[1])
						->condition('entity_id', $n)
						->fields(array(
							'entity_type' => 'node',
							'bundle' => $fie[0],
							'deleted' => 0,
							'language' => 'und',
							'delta' => 0,
							$fie[1].'_dat' => serialize(array(
								'vie' => (int)$sta['values']['vie'],
								'tpl' => $sta['values']['tpl'],
							)),
						))
						->execute();
				}
			
			
				
			}
			
			
		
		
		}
				cache_clear_all('*', 'cache_field', true);
		
  
		drupal_set_message(
			'Update '.
							db_select('node', 't')->condition('t.type', $fie[0])->countQuery()->execute()->fetchField()
			
			.' nodes'
		);
	
	}

}