<?php
function uc_acar_mode_ins(){

	$cid = uc_cart_get_id();
	$arg = json_decode($_POST['arg'], true);
	$arg_dat = json_decode($arg['dat'], true);

	uc_cart_add_item($arg['nid'], $arg['qty'], $arg_dat, $cid, false);


	$iid = db_select('uc_cart_products', 'p')
		->fields('p', array('cart_item_id'))
		->condition('p.cart_id', $cid)
		->condition('p.nid', $arg['nid'])
		->condition('p.data', serialize($arg_dat))
		->execute()
		->fetchField();

	$ent = entity_load('uc_cart_item', array($iid), null, true);
	$ent = $ent[$iid];

	$_SESSION['uc_cart_last_url'] = $_POST['url'];
	
	$res = array();
	$res['pri'] = (float)$ent->price;


	foreach(module_implements('uc_acar_act') as $mod){
		$cal = $mod.'_uc_acar_act';
		$cal($res);
	}

	drupal_json_output($res);
	
}
function uc_acar_mode_apl(){
	$cid = uc_cart_get_id();
	$ite = json_decode($_POST['ite'], true);
	$ite_dat = json_decode($ite['dat'], true);
	$arg = json_decode($_POST['arg'], true);
	$arg_dat = json_decode($arg['dat'], true);	
	db_update('uc_cart_products')
		->fields(array(
			'nid' => $arg['nid'],
			'qty' => $arg['qty'],
			'data' => serialize($arg_dat),
			'changed' => $_SERVER['REQUEST_TIME'],			
		))
		->condition('cart_id', $cid)
		->condition('nid', $ite['nid'])
		->condition('data', serialize($ite_dat))
		->execute();
	$iid = db_select('uc_cart_products', 't')
		->condition('t.cart_id', $cid)
		->condition('t.nid', $arg['nid'])
		->condition('t.data', serialize($arg_dat))
		->fields('t', array('cart_item_id'))
		->execute()
		->fetchField();
	$ent = entity_load('uc_cart_item', array($iid), null, true);
	$ent = $ent[$iid];
	$_SESSION['uc_cart_order_rebuild'] = true;
	
	$res = array();
	$res['pri'] = (float)$ent->price;
	
	foreach(module_implements('uc_acar_act') as $mod){
		$cal = $mod.'_uc_acar_act';
		$cal($res);
	}
	
	drupal_json_output($res);
}
function uc_acar_mode_rem(){

	$cid = uc_cart_get_id();
	$ite = json_decode($_POST['ite'], true);
	$ite_dat = json_decode($ite['dat'], true);

	uc_cart_remove_item($ite['nid'], $cid, $ite_dat);
	
	$_SESSION['uc_cart_order_rebuild'] = true;
	
	$res = array();
	
	foreach(module_implements('uc_acar_act') as $mod){
		$cal = $mod.'_uc_acar_act';
		$cal($res);
	}
	
	drupal_json_output($res);
}