mvca = {};
mvca.info = {};
mvca.info.ver = "1.10";
mvca.taga = {};
mvca.taga.typ = function(tag){
	return tag.toUpperCase() !== "INPUT";
};
mvca.taga.par = function(tag){
	tag = tag.toUpperCase();
	return mvca.taga.par.tab[tag] || "DIV";
};
mvca.taga.par.tab = {
	"LI": "UL",
	"TH": "THEAD",
	"TR": "TBODY",
	"TD": "TR"
};
mvca.taga.chi = function(tag){
	tag = tag.toUpperCase();
	return mvca.taga.chi.tab[tag] || "DIV";
};
mvca.taga.chi.tab = {
	"TABLE": "TR",
	"TBODY": "TR"
};
mvca.taga.dis = function(tag){
	tag = tag.toUpperCase();
	return mvca.taga.dis.tab[tag] || "inline";
};
mvca.taga.dis.tab = {
	"DIV" : "block",
	"TABLE": "table",
	"TR": "table-row",
	"TD": "table-cell",
	"TH": "table-cell"
};
mvca.taga.htm = function(htm){
	var t = false;
	var b = 0;
	while(b !== htm.length && !((65 <= htm.charCodeAt(b) && htm.charCodeAt(b) <= 90) || (97 <= htm.charCodeAt(b) && htm.charCodeAt(b) <= 124)))
		if(htm.charAt(b++) === "<") t = true;
	if(!t) return "DIV";
	var e = b;
	while(b !== htm.length && ((65 <= htm.charCodeAt(e) && htm.charCodeAt(e) <= 90) || (97 <= htm.charCodeAt(e) && htm.charCodeAt(e) <= 124)))
		++e;
	return htm.substr(b, e-b).toUpperCase();
};
mvca.imge = {};
mvca.imge.Put = function(img){
	for(var i in img) if(this[i] === undefined) this[i] = img[i]; return this;
};
mvca.imge.Set = function(img){
	for(var i in img) this[i] = img[i]; return this;
};
mvca.imge.setSty = function(val){
	mvca.styl.call.sty.call(this, undefined, val); return this;
};
mvca.imge.setAtr = function(atr, val){
	mvca.styl.call.sty.call(this, atr, val); return this;
};

mvca.imge.AtrHtm = function(atr, val){
	atr = mvca.imge.AtrHtm[atr] || atr;
	if(atr.charAt(0) !== "$"){
		return " "+atr+'="'+String(val).replace(/\"/g, "&quot;")+'"';
	};
	return "";
};
mvca.imge.AtrHtm.$typ = "type";
mvca.imge.AtrHtm.$nam = "name";
mvca.imge.AtrHtm.$cla = "class";
mvca.imge.AtrHtm.$sty = "style";

mvca.imge.AtrEle = function(atr, val, ele){
	atr = mvca.imge.AtrEle[atr] || atr;
	if(atr.charAt(0) !== "$"){
		if(atr === "style")
			ele.style.cssText = val;
		else
			ele[atr] = val;
	};
};
mvca.imge.AtrEle.$typ = "type";
mvca.imge.AtrEle.$nam = "name";
mvca.imge.AtrEle.$cla = "className";
mvca.imge.AtrEle.$sty = "style";
mvca.html = {};
mvca.html.img = function(img){
	if(img instanceof Array){
		var htm = ""; for(var i in img) htm += mvca.html.img(img[i]); return htm;
	};
	var htm = "";
	if(img.$tag){
		htm += "<"+img.$tag;
		var buf; 
		var cla = [];
		if(img.$lab !== undefined) cla.push("$"+img.$lab);
		if(img.$dat !== undefined) cla.push(String(JSON.stringify(img.$dat)).replace(/\"/g, "&quot;").replace(/\ /g, "\\u0020"));
		if(img.$sty !== undefined) cla.push(String(JSON.stringify({$sty: img.$sty})).replace(/\"/g, "&quot;").replace(/\ /g, "\\u0020"));
		if(img.$cla !== undefined) cla.push(img.$cla);
		if(img["class"] !== undefined) cla.push(img["class"]);
		if(cla.length !== 0){buf = img.$cla; img.$cla = cla.join(" ");};
		var atr;
		for(var a in img)
			htm += mvca.imge.AtrHtm(a, img[a]);
		if(buf) img.$cla = buf; else delete img.$cla;
		if(mvca.taga.typ(img.$tag)){
			htm += ">";
			if(img.$con !== undefined) htm += String(img.$con).replace(/\</g, "&lt;").replace(/\>/g, "&gt;").replace(/\n/g, "<br/>");
			if(img.$chi !== undefined) htm += mvca.html.img(img.$chi);
			htm += "</"+img.$tag+">";
		}else{
			if(img.$con !== undefined) htm += ' value="'+img.$con+'"';
			htm += "/>";
		};
	}else{
		if(img.$con !== undefined) htm += img.$con;
		if(img.$chi !== undefined) htm += mvca.html.img(img.$chi);
	};
	return htm;	
};
mvca.elem = {};
mvca.elem.setCon = function(val){
	if(this.tagName === "INPUT"){
		if(this.value !== val)
			if(document.activeElement !== this){
				this.value = val;
			}else{
				val = val.toString();
				var cur = this.value;
				this.value = val;
				var c = cur.length-1;
				var v = val.length-1;
				while(c !== -1 && v !== -1 && (cur.charAt(c) === val.charAt(v))){--c; --v;};
				var pos = v+1;
				if(this.setSelectionRange !== undefined)
					this.setSelectionRange(pos, pos);
				else
					{var ran = this.createTextRange(); ran.collapse(true); ran.moveEnd("character", pos); ran.moveStart("character", pos); ran.select();};
			};
	}else{
		if(this.textContent !== undefined) this.textContent = val; else this.innerText = val;
	};
};
mvca.elem.setHtm = function(htm){
	this.innerHTML = htm;
};
mvca.elem.LisHan = function(eve){
	var ele = eve.srcElement || this;
	var col = [];
	for(var han in ele.mvcLisCol[eve.type]) col.push(ele.mvcLisCol[eve.type][han]);
	for(var han in col) col[han].call(ele, ele.getVal(), eve);
};
mvca.elem.addLis = function(eve, han){
	if(!this.addEventListener) eve = eve === "input" && this.oninput === undefined ? "keyup" : eve;
	if(!this.mvcLisCol[eve]){
		this.mvcLisCol[eve] = [];
		this.mvcLisSiz[eve] = 0;
		if(this.addEventListener)
			this.addEventListener(eve, mvca.elem.LisHan, false);
		else
			this.attachEvent("on"+eve, mvca.elem.LisHan);		
	};
	this.mvcLisCol[eve].push(han);
	++this.mvcLisSiz[eve];
	return {eve: eve, han: this.mvcLisCol[eve].length-1};
};
mvca.elem.subLis = function(lis){if(lis && lis.eve){
	--this.mvcLisSiz[lis.eve];
	delete this.mvcLisCol[lis.eve][lis.han];
	if(this.mvcLisSiz[lis.eve] === 0){
		if(this.removeEventListener)
			this.removeEventListener(lis.eve, mvca.elem.LisHan, false);
		else
			this.detachEvent("on"+lis.eve, mvca.elem.LisHan);
		delete this.mvcLisSiz[lis.eve];
		delete this.mvcLisCol[lis.eve];
	};
delete lis.eve;};};
mvca.elem.setSty = function(val){
	mvca.styl.call.sty.call(this, undefined, val); return this;
};
mvca.elem.setAtr = function(atr, val){
	mvca.styl.call.sty.call(this, atr, val); return this;
};
mvca.elem.bui = function(){
	this.setCon = mvca.elem.setCon;
	this.setHtm = mvca.elem.setHtm;
	this.mvcLisCol = [];
	this.mvcLisSiz = [];
	this.addLis = mvca.elem.addLis;
	this.subLis = mvca.elem.subLis;	
	this.setSty = mvca.elem.setSty;
	this.setAtr = mvca.elem.setAtr;
	this.getVal = mvca.elem.getVal;
};
mvca.elem.getVal = function(typ){
	var val;
	switch(this.tagName){
	case "SELECT":
		if(this.multiple){
			val = [];
			for(var opt = 0; opt !== this.options.length; ++opt)
				if(this.options[opt].selected)
					val.push(this.options[opt].value);
		}else{
			for(var opt = 0; opt !== this.options.length; ++opt)
				if(this.options[opt].selected){
					val = this.options[opt].value;
					break;
				};
		};
	break;
	case "INPUT":
		switch(this.type){
		default:
			val = this.value;
		break;
		};
	break;
	};
	if(typ){
		if(val instanceof Object)
			for(var i in val) val[i] = mvca.elem.getVal.typ(typ, val[i]);
		else
			val = mvca.elem.getVal.typ(typ, val);
	}
	return val;
};
mvca.elem.getVal.typ = function(typ, val){
	switch(typ){
	case "bool": return val?true:false; break;
	case "int": return parseInt(val); break;
	case "float": return parseFloat(val); break;
	default: return val; break;
	};
};
mvca.tplt = {};
mvca.tplt.pos = 0;
mvca.tplt.nex = function(tpl){
	var c;
	while((c = tpl.charAt(mvca.tplt.pos)) && c !== "$" && c !== "@" && c !== "{")
		++mvca.tplt.pos;
	if(c === "$" || c === "@") ++mvca.tplt.pos;
	return c;
};
mvca.tplt.idn = function(tpl){
	var p = mvca.tplt.pos;
	var c;
	while((c = tpl.charCodeAt(mvca.tplt.pos)) &&  ((97 <= c && c <= 124) || (65 <= c && c <= 90) || (48 <= c && c <= 58) || c === 36 || c === 95))
		++mvca.tplt.pos;
	return tpl.substring(p, mvca.tplt.pos);
};
mvca.tplt.exp = function(tpl){
	if(tpl.charAt(mvca.tplt.pos) === "(" || tpl.charAt(mvca.tplt.pos) === "[" || tpl.charAt(mvca.tplt.pos) === "{"){
		var p = mvca.tplt.pos;
		var c;
		var l = 0;
		var t = "";
		do{
			c = tpl.charAt(mvca.tplt.pos);
			if(!t){
				switch(c){
				case "(": case "[": case "{": ++l; break;
				case ")": case "]": case "}": --l; break;
				case '"': t = '"'; ++l; break;
				case "'": t = "'"; ++l; break;
				};
			}else{
				if(c === t){t = ""; --l;}
				else if(c === "\\") ++mvca.tplt.pos;
			};
			++mvca.tplt.pos;
		}while(l !== 0);
		return tpl.substring(p, mvca.tplt.pos);
	}else{
		return "";
	};
};
mvca.tplt.arg = function(tpl){
	if(tpl.charAt(mvca.tplt.pos) === "("){
		var arg = mvca.tplt.exp(tpl, mvca.tplt.pos);
		return eval("["+arg.substring(1, arg.length-1)+"]");
	}else{
		return null;
	};
};
mvca.coll = {};
mvca.coll = function(htm, bas, sor, ind){
	this.par = undefined;
	this.bas = bas || this;
	this.sor = sor || undefined;
	this.ind = ind || undefined;
	this.ele = [];
	switch(mvca.taga.htm(htm)){
	case "TR":
		var box = document.createElement("div");
		box.innerHTML = "<table>"+htm+"</table>";
		var tab = box.childNodes[0];			
		for(var c = 0; c < tab.rows.length; ++c) this.ele.push(tab.rows[c]);
	break;
	case "TD":
		var box = document.createElement("div");
		box.innerHTML = "<table><tr>"+htm+"</tr></table>";
		var tab = box.childNodes[0];
		for(var c = 0; c < tab.rows[0].cells.length; ++c) this.ele.push(tab.rows[0].cells[c]);
	break;
	default:
		box = document.createElement(mvca.taga.par(mvca.taga.htm(htm)));
		box.innerHTML = htm;
		while(box.childNodes.length !== 0) this.ele.push(box.removeChild(box.childNodes[0]));
	break;
	};
	if(!this.ele.length){
		this.ele[0] = document.createElement("SPAN");
		this.ele[0].style.display = "none";
	};
	this.ele[0].$col = this;
	this.ele[this.ele.length-1].$col = this;
	this.lab = {};
	this.fun = {};
	for(var e in this.ele) mvca.coll.bui.call(this, this.ele[e]);
	mvca.coll.piv.call(this);
	this.beg = mvca.coll.beg; this.end = mvca.coll.end; this.nex = mvca.coll.nex; this.pre = mvca.coll.pre;
	this.she = mvca.coll.she; this.tar = mvca.coll.tar; this.fre = mvca.coll.fre;
	this.ins = mvca.coll.ins; this.rem = mvca.coll.rem;
};
mvca.coll.bui = function(ele){
	if(ele.className){
		var tpl = ele.className;
		mvca.tplt.pos = 0;		
		var bui = false;
		var nex;
		while(nex = mvca.tplt.nex(tpl)){
			switch(nex){
			case "$":
				var lab = mvca.tplt.idn(tpl);
				if(!this.lab[lab]) this.lab[lab] = [];
				this.lab[lab].push(ele);
				bui = true;
			break;
			case "@":
				var fun = mvca.tplt.idn(tpl);
				if(!this.fun[fun]) this.fun[fun] = [];
				this.fun[fun].push([ele, {}, mvca.tplt.arg(tpl)]);
				bui = true;
			break;
			case "{":
				var dat = JSON.parse(mvca.tplt.exp(tpl));
				for(var d in dat) ele[d] = dat[d];
			break;
			};
		};
		if(bui) mvca.elem.bui.call(ele);
	};
	for(var n = 0; n !== ele.childNodes.length; ++n)
		mvca.coll.bui.call(this, ele.childNodes[n]);
};
mvca.coll.piv = function(){
	var piv = (this.lab.$par !== undefined ? 1 : 0) | (this.lab.$chi !== undefined ? 2 : 0);
	if(piv){
		if(piv === 1)
			this.lab.$chi = [this.lab.$par[0].appendChild(document.createElement(mvca.taga.chi(this.lab.$par[0].tagName)))];
		else
		if(piv === 2)
			this.lab.$par = [this.lab.$chi[0].parentNode];
		this.lef = this.lab.$par[0].insertBefore(document.createElement(this.lab.$chi[0].tagName), this.lab.$chi[0]);
		this.rig = this.lab.$chi[0];
		this.lef.style.display = "none";
		this.rig.style.display = "none";
		this.piv = {ele: [this.rig]};
		this.lef.$col = this.piv;
		this.rig.$col = this.piv;	
	};
};
mvca.coll.beg = function(){return this.lef.nextSibling.$col;};
mvca.coll.end = function(){return this.piv;};
mvca.coll.nex = function(){return this.ele[this.ele.length-1].nextSibling.$col;};
mvca.coll.pre = function(){return this.ele[0].previousSibling.$col;};
mvca.coll.EleAth = function(ele, par, bef){
	for(var e in ele) par.insertBefore(ele[e], bef);
};
mvca.coll.EleDth = function(ele, par){
	for(var e in ele) par.removeChild(ele[e]);
};
mvca.coll.she = function(she){
	if(she){
		if(she.nodeType){
			mvca.coll.EleAth(this.ele, she, null);
		}else{
			var tar = she.end();
			if(she.sor){tar = she.beg(); while(tar !== she.end() && !she.sor(this.bas, tar.bas)) tar = tar.nex();};
			mvca.coll.EleAth(this.ele, tar.ele[0].parentNode, tar.ele[0]);
			this.par = she;
			return false;
		};
		return true;
	};
	return false;
};
mvca.coll.tar = function(tar){
	if(tar){
		if(tar.nodeType){
			mvca.coll.EleAth(this.ele, tar.parentNode, tar);
		}else{
			var she = tar.par;
			if(she.sor){tar = she.beg(); while(tar !== she.end() && !she.sor(this.bas, tar.bas)) tar = tar.nex();};
			mvca.coll.EleAth(this.ele, tar.ele[0].parentNode, tar.ele[0]);
			this.par = she;
		};
		return true;
	};
	return false;
};
mvca.coll.fre = function(){
	var she = this.par || this.ele[0].parentNode;
	if(she){
		if(she.nodeType){
			mvca.coll.EleDth(this.ele, she);
		}else{
			this.par = undefined;
			mvca.coll.EleDth(this.ele, this.ele[0].parentNode);
		};
		return true;
	};
	return false;
};
mvca.coll.ins = function(htm, bas, sor, ind){
	var col = new mvca.coll(htm, bas, sor, ind); col.she(this); return col;
};
mvca.coll.rem = function(col){
	col.fre();
};
mvca.styl = {};
mvca.styl.swit = function(swi){
	this.$sty = "swi";
	for(var s in swi)
		this[s] = swi[s];
};
mvca.styl.mult = function(mul){
	this.$sty = "mul";
	for(var m in mul)
		if(mul[m] instanceof Array) this[m] = mul[m]; else if(mul[m]) this[m] = [mul[m]]; else this[m] = [];
	if(!this.fir) this.fir = [];
	if(!this.Mid) this.Mid = [];
	if(!this.las) this.las = [];
};
mvca.styl.call = function(met){
	return function(ele, sty, dat, len, stp){
		if(this.$sty) dat = this.$sty;
		if(len === undefined) len = 1;
		if(stp === undefined) stp = 0;
		switch(mvca.styl.call.typ(sty)){
		case 1:
			mvca.styl.call[met][1].call(this, ele, sty, dat, len, stp);
		break;
		case 3:
			mvca.styl.call[met][3].call(this, ele, sty, dat, len, stp);
		break;
		case 7:
			mvca.styl.call[met].call(this, ele, sty[stp%sty.length], dat, len, stp);
		break;
		case 11:
			if(sty[len])
				mvca.styl.call[met].call(this, ele, sty[len][stp % sty[len].length], dat, len, stp);
			else
			if(stp < sty.fir.length)
				mvca.styl.call[met].call(this, ele, sty.fir[stp % sty.fir.length], dat, len, stp);
			else
			if(len-sty.las.length <= stp)
				mvca.styl.call[met].call(this, ele, sty.las[(stp-(len-sty.las.length)) % sty.las.length], dat, len, stp);
			else
			if(0 < sty.Mid.length)
				mvca.styl.call[met].call(this, ele, sty.Mid[(stp-sty.fir.length) % sty.Mid.length], dat, len, stp);
		break;
		case 19:
			mvca.styl.call[met].call(this, ele, sty[dat], dat, len, stp);
		break;
		};
		return this;
	};
};
mvca.styl.call.sty = mvca.styl.call("sty");
mvca.styl.call.atr = mvca.styl.call("atr");
mvca.styl.call.typ = function(sty){
	return (
		(sty !== undefined ? 1 : 0) |
		(sty instanceof Object ? 2 : 0) |
		(sty instanceof Array ? 4 : 0) |
		(sty && sty.$sty === "mul" ? 8 : 0) |
		(sty && sty.$sty === "swi" ? 16 : 0)
	);
};
mvca.styl.call.sty[1] = function(ele, sty, dat, len, stp){
	if(sty.charAt(sty.length-1) === ";")
		mvca.styl.call.atr.call(this, "$sty", sty, dat, len, stp);
	else
		mvca.styl.call.atr.call(this, "$cla", sty, dat, len, stp);
};
mvca.styl.call.atr[1] = function(ele, sty, dat, len, stp){
	if(this.nodeType){
		mvca.imge.AtrEle(ele, sty, this);
	}else{
		this[ele] = sty;
	};
};
mvca.styl.call.sty[3] = function(ele, sty, dat, len, stp){
	for(var a in sty)
		if(a !== "$chi")
			mvca.styl.call.atr.call(this, a, sty[a], dat, len, stp);
		else{
			var chi = this.childNodes || this.$chi;
			for(var c in chi)
				mvca.styl.call.sty.call(chi[c],
					ele,
					sty.$chi[c%sty.$chi.length],
					dat,
					(chi.length/sty.$chi.length>>0) + (c%sty.$chi.length < chi.length%sty.$chi.length),
					c/sty.$chi.length>>0
				);
		};
};
mvca.scri = {};
mvca.scri.par = function(){
	var scr = document.getElementsByTagName("script"); return scr[scr.length-1].parentNode;
};
mvca.scri.eva = function(obj, scr){
	with(obj) return eval(scr);
};
mvca.line = {}
mvca.line.bui = function(lin){
	if(!lin.$$nex){
		if(lin instanceof Array){
			var fir;
			var pre = {};
			for(var i in lin)
				if(i.charAt(0) !== "$"){
					if(!fir) fir = lin[i];
					pre.$$nex = lin[i];
					pre = lin[i];
				};
			pre.$$nex = fir;
			lin.$$nex = fir ? fir : lin;
		}else{
			lin.$$nex = lin;
		};
	};
	return lin;	
};


mvca.proc = function(cla, met, bas){
	this.cla = cla;
	this.met = met;
	this.bas = bas || this;
	this.stm = [];
	this.run = mvca.proc.run;
	this.nex = mvca.proc.nex;
	this.get = mvca.proc.get;
	this.set = mvca.proc.set;
	this.ret = mvca.proc.ret;
};
mvca.proc.met = function(met){
	for(var m in this.met)
		if(this.met[m] === met) return m;
};
mvca.proc.run = function(met, arg){
	mvca.proc.runA.call(this, this.met[met], arg);
};
mvca.proc.nex = function(stm, arg){
	mvca.proc.nexA.call(this, stm.$cur, arg, stm);
};
mvca.proc.tes = function(dep, tes, met){
	for(var t in tes) if(tes[t][0] === met && tes[t][1] < dep) return true;
	return false;
};
mvca.proc.runA = function(met, arg){
	var stm = met.run.call(this.bas, arg);
	if(stm !== undefined){
		if(!stm.$cur){
			stm.$cur = met;
			stm.$cur.beg.call(this.bas, arg, stm);
		}else{
			var nex = true;
			while(stm.$nex.length !== 0){
				if(mvca.proc.tes(stm.$nex.length, met.com, stm.$nex[stm.$nex.length-1].met)){
					--stm.$nex.length;
					nex = false;
					break;
				}else
				if(mvca.proc.tes(stm.$nex.length, met.ove, stm.$nex[stm.$nex.length-1].met)){
					--stm.$nex.length;
				}else{
					break;
				};
			};
			if(nex)
				stm.$nex[stm.$nex.length] = {met: met, arg: arg};
		};

	};
};
mvca.proc.nexA = function(met, arg, stm){
	if(met.end) met.end.call(this.bas, arg, stm);
	var cur = stm.$cur; stm.$cur = null;
	if(stm.$nex.length !== 0){
		var nex = stm.$nex[0]; stm.$nex.splice(0,1);
		stm.$cur = nex.met;
		stm.$cur.beg.call(this.bas, nex.arg, stm);
	};

};
mvca.proc.get = function(arg){
	var ind = this.cla.ind(arg);
	if(!this.stm[ind]){
		this.stm[ind] = new this.cla.bui(arg);
		this.stm[ind].$ind = ind;
		this.stm[ind].$cur = null;
		this.stm[ind].$nex = [];		
	};
	return this.stm[ind];
};
mvca.proc.set = function(stm, arg){
	delete this.stm[stm.$ind];
	this.cla.bui.call(stm, arg);
	stm.$ind = this.cla.ind(arg);
	this.stm[stm.$ind] = stm;
};
mvca.proc.ret = function(stm){
	if(stm.$nex.length === 0){
		delete this.stm[stm.$ind];
	};
};
mvca.ajax = {};
mvca.ajax.req = function(prm){
	var req;
	if(window.XMLHttpRequest) req = new XMLHttpRequest(); else req = new ActiveXObject("Microsoft.XMLHTTP");
	req.open("POST", prm.url, true);
	var sen = "";
	var i = 0;
	for(var d in prm.dat){
		if(i++ !== 0) sen += "&";
		sen += d.charAt(0) === "$" ? d.substr(1)+"="+JSON.stringify(prm.dat[d]) : d+"="+prm.dat[d];
	};
	req.prm = prm;
	if(prm.met) req.onreadystatechange = mvca.ajax.req.Res;
	req.setRequestHeader("Content-Type", "application/x-www-form-urlencoded; charset=utf-8");
	req.setRequestHeader("Content-length", sen.length);
    req.setRequestHeader("Connection", "close");
	req.send(sen);
};
mvca.ajax.req.Res = function(){
	if(this.readyState === 4 && this.status === 200)
		this.prm.met.call(this.prm.obj, this.responseText !== "" ? JSON.parse(this.responseText) : undefined, this.prm.arg);
};
mvca.ajax.pro = function(stm, req, def){
	mvca.ajax.pro.pro.run("def", {stm: stm, def: def});
	if(req !== undefined) mvca.ajax.pro.pro.run("req", {stm: stm, req: req});
};
mvca.ajax.pro.cla = {};
mvca.ajax.pro.cla.ind = function(arg){return arg;};
mvca.ajax.pro.cla.bui = function(arg){};
mvca.ajax.pro.met = {};
mvca.ajax.pro.met.def = {
	run: function(dat){
		var stm = this.get(dat.stm);
		if(stm.$cur === mvca.ajax.pro.met.def){			
			clearTimeout(stm.def);
			stm.def = setTimeout(function(){mvca.ajax.pro.pro.nex(stm, dat);}, dat.def || 550);
		}else
		if(stm.$nex[0] && stm.$nex[0].met === mvca.ajax.pro.met.def){
			stm.$nex[0].arg.def = dat.def || 550;
		};
		return stm;
	},
	beg: function(dat, stm){
		stm.def = setTimeout(function(){mvca.ajax.pro.pro.nex(stm, dat);}, dat.def || 550);
	}
};
mvca.ajax.pro.met.req = {
	run: function(dat){
		return this.get(dat.stm);
	},
	beg: function(dat, stm){
		dat.req.arg = {
			obj: dat.req.obj,
			met: dat.req.met,
			arg: dat.req.arg,
			stm: stm
		};
		dat.req.obj = this;
		dat.req.met = function(ret, res){
			if(res.met) res.met.call(res.obj, ret, res.srg);
			this.nex(res.stm, ret);
		};
		mvca.ajax.req(dat.req);
	}
};
mvca.ajax.pro.met.def.Com = [];
mvca.ajax.pro.met.def.Ove = [];
mvca.ajax.pro.met.req.Com = [];
mvca.ajax.pro.met.req.Ove = [[mvca.ajax.pro.met.def, 1], [mvca.ajax.pro.met.req, 0]];
mvca.ajax.pro.pro = new mvca.proc(mvca.ajax.pro.cla, {def: mvca.ajax.pro.met.def, req: mvca.ajax.pro.met.req});


mvca.even = function(){	
	this.eveCal = mvca.even.eveCal;
	this.eveEve = {};
	this.eveSiz = {};
	this.addEve = mvca.even.addEve;
	this.subEve = mvca.even.subEve;
};

mvca.even.eveCal = function(eve, arg){
	var e = this.eveEve[eve]; for(var s in e){
		e[s].met.apply(e[s].obj, arg);		
	}
};
mvca.even.EveInc = function(eve){
	if(!this.eveSiz[eve]){this.eveEve[eve] = []; this.eveSiz[eve] = 0};
	++this.eveSiz[eve];
};
mvca.even.EveDec = function(eve){
	--this.eveSiz[eve];	
	if(this.eveSiz[eve] === 0){delete this.eveEve[eve]; delete this.eveSiz[eve];};
};
mvca.even.addEve = function(eve, obj, met, cal){
	if(cal) met.apply(obj, cal);
	mvca.even.EveInc.call(this, eve);
	return this.eveEve[eve][this.eveEve[eve].length] = {eve: eve, obj: obj, met: met, ind: this.eveEve[eve].length};
};
mvca.even.subEve = function(sub, cal){if(sub && sub.eve){
	delete this.eveEve[sub.eve][sub.ind];
	mvca.even.EveDec.call(this, sub.eve);
	if(cal) sub.met.apply(sub.obj, cal);
delete sub.eve;};};
mvca.mvca = {};

mvca.mvca.obj = [];

mvca.mvca.func = function(bas, cla, n0, n1, d1, d0){

bas[cla] = mvca.mvca.func.New(bas, cla, n0, n1);
bas[cla]._ = mvca.mvca.func.Del(bas, cla, d1, d0);

bas[cla].nam = cla.substring(0, 3);

bas[cla].csr = mvca.mvca.func.csr(bas, cla);
bas[cla].dsr = mvca.mvca.func.dsr(bas, cla);
bas[cla].cnt = mvca.mvca.func.cnt;
bas[cla].dnt = mvca.mvca.func.dnt;
bas[cla].ath = mvca.mvca.func.ath;
bas[cla].dth = mvca.mvca.func.dth;

bas[cla].ins = mvca.mvca.func.ins(bas, cla);
bas[cla].rem = mvca.mvca.func.rem(bas, cla);
bas[cla].ful = mvca.mvca.func.ful(bas, cla);
bas[cla].upd = mvca.mvca.func.upd(bas, cla);

bas[cla].adr = mvca.mvca.func.adr;
bas[cla].get = mvca.mvca.func.get;
bas[cla].way = mvca.mvca.func.way;

};
mvca.mvca.func.New = function(bas, cla, n0, n1){
return function(prm, arg){
	this.$idn = mvca.mvca.obj.push(this)-1;
	this.$bas = prm.bas || this;
	this.$par = prm.par || this;
	this.$cla = mvca.line.bui(prm.cla || []);
	this.$thm = mvca.line.bui(prm.thm || []);
	this.$bui = mvca.mvca.func.bui;
	this.$ref = mvca.mvca.func.ref;
	var buf = {};
	n0.call(this, buf, prm, arg);
	bas[cla].csr.call(this, arg);
	n1.call(this, buf, prm, arg);
};
};
mvca.mvca.func.Del = function(bas, cla, d1, d0){
return function(){
	var buf = {};
	d1.call(this, buf);
	bas[cla].dsr.call(this);
	d0.call(this, buf);
	delete mvca.mvca.obj[this.$idn];
};
};
mvca.mvca.func.csr = function(bas, cla){
return function(arg){
	if(arg){
		var c = this.$cla.$$nex;
		if(c.$csr) c.$csr.call(this, arg);
		this.$bui("csr", c);
		if(this.$ind === undefined) this.$ind = arg.$ind !== undefined ? arg.$ind : this.$idn;
		for(var o in this.$fun) for(var i in this.$fun[o])
			this.$fun[o][i][0]["$"+bas[cla].nam] = this;
		bas[cla].ful.call(this, arg.$chi);
		bas[cla].cnt.call(this);
	};
};
};
mvca.mvca.func.dsr = function(bas, cla){
return function(){
	if(this.$ind !== undefined){
		var c = this.$cla.$$nex;
		bas[cla].dnt.call(this);
		bas[cla].ful.call(this, null);
		for(var o in this.$fun) for(var i in this.$fun[o])
			this.$fun[o][i][0]['$'+bas[cla].nam] = undefined;
		this.$bui("dsr", c);
		if(c.$dsr) c.$dsr.call(this);
		delete this.$ind;
	};
};
};
mvca.mvca.func.cnt = function(){
	if(this.$bas.$con){
		var c = this.$cla.$$nex;
		for(var o in this.$fun) for(var i in this.$fun[o]) this.$fun[o][i][0].$con = this.$bas.$con;		
		if(c.$cnt) c.$cnt.call(this);
		this.$bui("cnt", c);
		this.$ref(c);
		return true;
	};
	return false;
};	
mvca.mvca.func.dnt = function(){
	if(this.$bas.$con){
		var c = this.$cla.$$nex;
		//
		this.$bui("dnt", c);		
		if(c.$dnt) c.$dnt.call(this);	
		for(var o in this.$fun) for(var i in this.$fun[o]) this.$fun[o][i][0].$con = undefined;
		return true;
	};
	return false;
};
mvca.mvca.func.ath = function(con){
	if(!this.$con){
		this.$con = con;
		if(this.$ind !== undefined) mvca.mvca.func.cnt.call(this);
	};
};
mvca.mvca.func.dth = function(){
	if(this.$con){
		if(this.$ind !== undefined) mvca.mvca.func.dnt.call(this);
		delete this.$con;
	};
};
mvca.mvca.func.ins = function(bas, cla){
return function(arg){
	var ite = new bas[cla](
		{bas: this.$bas, par: this, cla: this.$cla.$$nex, thm: this.$thm.$$nex},
		arg
	);
	this.$chi[ite.$ind] = ite;
	return ite;
};
};
mvca.mvca.func.rem = function(bas, cla){
return function(ite){
	var i = ite.$ind;
	bas[cla]._.call(this.$chi[i]);
	delete this.$chi[i];
};
};
mvca.mvca.func.ful = function(bas, cla){
return function(arg){
	if(this.$chi){
		for(var i in this.$chi){
			bas[cla].rem.call(this, this.$chi[i]);
		};
		if(arg){
			for(var i in arg){
				bas[cla].ins.call(this, arg[i]);
			};
		};
	};
};
};
mvca.mvca.func.upd = function(bas, cla){
return function(ite, arg){
	bas[cla].dsr.call(ite);
	bas[cla].csr.call(ite, arg);
	return ite;
};
};
mvca.mvca.func.adr = function(ite){
	var adr = [];
	while(ite !== this){adr.unshift(ite.$ind); ite = ite.$par;};
	return adr;
};
mvca.mvca.func.get = function(adr){
	var lev = 0; var ite = this;
	while(lev !== adr.length) ite = ite.$chi[adr[lev++]];
	return ite;
};
mvca.mvca.func.way = function(ite){
	var way = [];
	while(ite !== this){way.unshift(ite.$idn); ite = ite.$par;}; way.unshift(this.$idn);
	return way;
};
mvca.mvca.func.bui = function(act, cla){
	var cla = cla || this.$cla.$$nex;
	__ = act;
	if(act !== "csr" && act !== "cnt")
		for(var obj in this.$fun){
			if(cla[obj].$dnt && act !== "dsr")
				for(var o in this.$fun[obj]){
					_ = this.$fun[obj][o][1];
					cla[obj].$dnt.apply(this.$fun[obj][o][0], this.$fun[obj][o][2]);
				};
			if(cla[obj].$dsr && act !== "dnt")
				for(var o in this.$fun[obj]){
					_ = this.$fun[obj][o][1];
					cla[obj].$dsr.apply(this.$fun[obj][o][0], this.$fun[obj][o][2]);
				};
		};
	if(act !== "dsr" && act !== "dnt")
		for(var obj in this.$fun){
			if(cla[obj].$csr && act !== "cnt")
				for(var o in this.$fun[obj]){
					_ = this.$fun[obj][o][1];
					cla[obj].$csr.apply(this.$fun[obj][o][0], this.$fun[obj][o][2]);
				};
			if(cla[obj].$cnt && act !== "csr")
				for(var o in this.$fun[obj]){
					_ = this.$fun[obj][o][1];
					cla[obj].$cnt.apply(this.$fun[obj][o][0], this.$fun[obj][o][2]);
				};
		};
};
mvca.mvca.func.ref = function(cla){
	var c = cla || this.$cla.$$nex;
	if(c.$ref) c.$ref.call(this);
	for(var obj in this.$fun){
		if(c[obj].$ref)
			for(var o in this.$fun[obj])
				c[obj].$ref.call(this.$fun[obj][o][0]);
	};
};
mvca.mvca.func(
	mvca.mvca,
	"mode",
	function(prm, arg){
	},
	function(prm, arg){
	},
	function(){
	},
	function(){
	}
);
mvca.mvca.mode._ins = mvca.mvca.mode.ins;
mvca.mvca.mode.ins = function(arg){
	var ite = mvca.mvca.mode._ins.call(this, arg);
	if(this.$bas.$con) this.$bas.$con.eveCal("$ins"+mvca.mvca.mode.adr.call(this.$bas, this), [ite]);
	return ite;	
};
mvca.mvca.mode._rem = mvca.mvca.mode.rem;
mvca.mvca.mode.rem = function(ite){
	if(this.$bas.$con) this.$bas.$con.eveCal("$rem"+mvca.mvca.mode.adr.call(this.$bas, this), [ite.$ind]);
	mvca.mvca.mode._rem.call(this, ite);
};
mvca.mvca.mode._upd = mvca.mvca.mode.upd;
mvca.mvca.mode.upd = function(ite, arg){
	mvca.mvca.mode._upd.call(this, ite, arg);
	if(this.$bas.$con) this.$bas.$con.eveCal("$upd"+mvca.mvca.mode.adr.call(this.$bas, this), [ite.$ind, ite]);
	return ite;	
};

mvca.mvca.func(
	mvca.mvca,
	"view",
	function(buf, prm, arg){
		this.$col = new mvca.coll(this.$thm.$$nex.$tpl, arg, this.$thm.$$nex.$sor);
		this.$fun = this.$col.fun;
	},
	function(buf, prm, arg){
		this.$col.she(prm.she) || this.$col.tar(prm.tar) || (this.$par !== this ? this.$col.she(this.$par.$col) : undefined);
	},
	function(buf){
		this.$col.fre();
	},
	function(buf){
		delete this.$fun;
		delete this.$col;		
	}
);
mvca.mvca.view._csr = mvca.mvca.view.csr;
mvca.mvca.view.csr = function(arg){
	this.$mod = arg;
	mvca.mvca.view._csr.call(this, arg);	
};
mvca.mvca.view._dsr = mvca.mvca.view.dsr;
mvca.mvca.view.dsr = function(){
	mvca.mvca.func.dsr.call(this);
	delete this.$mod;
};
mvca.mvca.view.cnt = function(){
	if(mvca.mvca.func.cnt.call(this)){
		this.$eve = {}; var adr = mvca.mvca.view.adr.call(this.$bas, this).toString();
		if(this.$chi){
			this.$eve.ins = this.$bas.$con.addEve("$ins"+adr, this, mvca.mvca.view._ins);
			this.$eve.rem = this.$bas.$con.addEve("$rem"+adr, this, mvca.mvca.view._rem);
			this.$eve.upd = this.$bas.$con.addEve("$upd"+adr, this, mvca.mvca.view._upd);
		};
	};
};
mvca.mvca.view.dnt = function(){
	if(mvca.mvca.func.dnt.call(this)){
		if(this.$chi){
			this.$bas.$con.subEve(this.$eve.upd);
			this.$bas.$con.subEve(this.$eve.rem);
			this.$bas.$con.subEve(this.$eve.ins);
		};
		delete this.$eve;
	};
};
mvca.mvca.view._ins = function(arg){
	mvca.mvca.view.ins.call(this, arg);
};
mvca.mvca.view._rem = function(obj){
	mvca.mvca.view.rem.call(this, this.$chi[obj]);
};
mvca.mvca.view._upd = function(obj, arg){
	mvca.mvca.view.upd.call(this, this.$chi[obj], arg);
};
mvca.mvca.cont = function(){

	this.$idn = mvca.mvca.obj.push(this)-1;

	this.$mod = null;
	this.$vie = [];
	
	mvca.even.call(this);

	this.$modCnt = mvca.mvca.cont.$modCnt;
	this.$modDnt = mvca.mvca.cont.$modDnt;	
	this.$vieCnt = mvca.mvca.cont.$vieCnt;
	this.$vieDnt = mvca.mvca.cont.$vieDnt;

};
mvca.mvca.cont._ = function(){
	for(var v in this.$vie) this.$vieDnt(this.$vie[v]);
	this.$modDnt();
	delete mvca.mvca.obj[this.$idn];	
};
mvca.mvca.cont.$modCnt = function(mod){
	this.$mod = mod;
	mvca.mvca.mode.ath.call(this.$mod, this);
	for(var v in this.$vie) mvca.mvca.view.csr.call(this.$vie[v], this.$mod);
	return mod;
};
mvca.mvca.cont.$modDnt = function(){
	for(var v in this.$vie) mvca.mvca.view.dsr.call(this.$vie[v]);
	mvca.mvca.mode.dth.call(this.$mod);
	var mod = this.$mod; this.$mod = null;
	return mod;
};
mvca.mvca.cont.$vieCnt = function(vie){
	this.$vie[vie.$idn] = vie;
	mvca.mvca.view.ath.call(vie, this);
	if(this.$mod) mvca.mvca.view.csr.call(vie, this.$mod);
	return vie;
};
mvca.mvca.cont.$vieDnt = function(vie){
	if(this.$mod) mvca.mvca.view.dsr.call(vie);
	mvca.mvca.view.dth.call(vie);
	delete this.$vie[vie.$idn];	
	return vie;
};
mvca.mvca.engi = function(){
	var eng = function(arg){
		this._con = new mvca.mvca.cont();
		mvca.mvca.mode.call(this, {cla: eng.mode}, arg || {});
		this._con.$modCnt(this);
		this.VieNew = function(she, thm, vie){
			if(thm === undefined) thm = eng[vie || "view"].$thm;
			if(typeof(thm) === "string")  thm = [{$tpl: thm}];
			else if((thm instanceof Object) && !(thm instanceof Array)) thm = [thm];
			return this._con.$vieCnt(new mvca.mvca.view({cla: eng[vie || "view"], thm: thm, she: she}));
		};
		this.VieDel = mvca.mvca.engi.VieDel;
	};
	eng._ = mvca.mvca.engi._;
	return eng;
};
mvca.mvca.engi._ = function(){
	for(var v in this._con.$vie) this.VieDel(this._con.$vie[v]);
	this._con.$modDnt(this);
	mvca.mvca.mode._.call(this);
	mvca.mvca.cont._.call(this._con); delete this._con;
};
mvca.mvca.engi.VieDel = function(vie){
	mvca.mvca.view._.call(this._con.$vieDnt(vie));
};

